Index: trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp
===================================================================
--- trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 134)
+++ trunk/modules/vci_cc_xcache_wrapper_v4/caba/source/src/vci_cc_xcache_wrapper_v4.cpp	(revision 140)
@@ -55,49 +55,127 @@
 ///////////////////////////////////////////////////////////////////////////////
 
-#include <cassert>
 #include <iomanip>
 #include "arithmetics.h"
+#include "size.h"
 #include "../include/vci_cc_xcache_wrapper_v4.h"
 
+// =====[ DEBUG ]====================================
+
+#define ASSERT_VERBOSE
+#define ASSERT_NCYCLES m_cpt_total_cycles
+
+#include "debug.h"
+
 #if CC_XCACHE_WRAPPER_DEBUG
-# define PRINTF(msg...) do { if (m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN) printf(msg); } while (0); 
+# define PRINTF(msg...) PRINTF_COND(m_cpt_total_cycles>=CC_XCACHE_WRAPPER_DEBUG_CYCLE_MIN,msg)
 #else
 # define PRINTF(msg...)
 #endif
 
-# define ASSERT(cond,msg) assert ((cond) and msg);
-
+// =====[ FIFO_RSP ]=================================
+
+// FIXME : une FIFO avec le numéro du cache !
 #if CC_XCACHE_WRAPPER_FIFO_RSP
-# define CACHE_MISS_BUF_ALLOC
-# define CACHE_MISS_BUF_DEALLOC
-# define CACHE_MISS_BUF_RESET(c)        while (r_##c##cache_miss_buf.size()>0) {r_##c##cache_miss_buf.pop();}
-# define CACHE_MISS_BUF_REQ_INIT(c)
-# define CACHE_MISS_BUF_RSP_VAL(c,n)    (r_##c##cache_miss_buf.size()>0)
-# define CACHE_MISS_BUF_RSP_ACK(c)      (r_##c##cache_miss_buf.size()<2)
-# define CACHE_MISS_BUF_RSP_DATA(c,n)   r_##c##cache_miss_buf.front()
-# define CACHE_MISS_BUF_RSP_POP(c)      do { r_##c##cache_miss_buf.pop();} while (0)
-# define CACHE_MISS_BUF_RSP_PUSH(c,n,d) do { r_##c##cache_miss_buf.push(d);} while (0)
-# define CACHE_MISS_BUF_RSP_PRINT(c)    do { PRINTF("    * cache_miss_buf - size : %d\n",r_##c##cache_miss_buf.size());} while (0)
+# define CACHE_MISS_BUF_ALLOC             do { \
+                                              r_icache_miss_buf = new std::queue<data_t> [m_nb_icache]; \
+                                              r_dcache_miss_buf = new std::queue<data_t> [m_nb_dcache]; \
+                                          } while (0)
+# define CACHE_MISS_BUF_DEALLOC           do { \
+                                              delete [] r_icache_miss_buf; \
+                                              delete [] r_dcache_miss_buf; \
+                                          } while (0)
+# define CACHE_MISS_BUF_RESET(c)          do { \
+                                              for (uint32_t x=0; x<m_nb_##c##cache; ++x) { \
+                                                  while (r_##c##cache_miss_buf[x].size()>0) { \
+                                                      r_##c##cache_miss_buf[x].pop(); \
+                                                  } \
+                                              } \
+                                          } while (0)
+# define CACHE_MISS_BUF_REQ_INIT(c,x)      
+# define CACHE_MISS_BUF_RSP_VAL(c,x,n)    (r_##c##cache_miss_buf[x].size()>0)
+# define CACHE_MISS_BUF_RSP_ACK(c,x)      (r_##c##cache_miss_buf[x].size()<2)
+# define CACHE_MISS_BUF_RSP_DATA(c,x,n)   r_##c##cache_miss_buf[x].front()
+# define CACHE_MISS_BUF_RSP_POP(c,x)      do {                                            \
+                                              r_##c##cache_miss_buf[x].pop(); \
+                                          } while (0)
+# define CACHE_MISS_BUF_RSP_PUSH(c,x,n,d) do { \
+                                              r_##c##cache_miss_buf[x].push(d); \
+                                          } while (0)
+# define CACHE_MISS_BUF_RSP_PRINT(c)      do { \
+                                              for (uint32_t x=0; x<m_nb_##c##cache; ++x) { \
+                                                  PRINTF("    * cache_miss_buf - size : %d\n",r_##c##cache_miss_buf[x].size()); \
+                                              } \
+                                          } while (0)
+#else                                      
+# define CACHE_MISS_BUF_ALLOC             do { \
+                                              r_icache_miss_val = new bool   * [m_nb_icache]; \
+                                              r_icache_miss_buf = new data_t * [m_nb_icache]; \
+                                              for (uint32_t x=0; x<m_nb_icache;++x) { \
+                                                  r_icache_miss_val [x] = new bool   [m_icache_words]; \
+                                                  r_icache_miss_buf [x] = new data_t [m_icache_words]; \
+                                              } \
+                                              r_dcache_miss_val = new bool   * [m_nb_dcache]; \
+                                              r_dcache_miss_buf = new data_t * [m_nb_dcache]; \
+                                              for (uint32_t x=0; x<m_nb_dcache;++x) { \
+                                                  r_dcache_miss_val [x] = new bool   [m_dcache_words]; \
+                                                  r_dcache_miss_buf [x] = new data_t [m_dcache_words]; \
+                                              } \
+                                          } while (0)
+# define CACHE_MISS_BUF_DEALLOC           do { \
+                                              for (uint32_t x=0; x<m_nb_icache;++x) { \
+                                                  delete [] r_icache_miss_val[x]; \
+                                                  delete [] r_icache_miss_buf[x]; \
+                                              } \
+                                              delete [] r_icache_miss_val; \
+                                              delete [] r_icache_miss_buf; \
+                                              for (uint32_t x=0; x<m_nb_dcache;++x) { \
+                                                  delete [] r_dcache_miss_val[x]; \
+                                                  delete [] r_dcache_miss_buf[x]; \
+                                              } \
+                                              delete [] r_dcache_miss_val; \
+                                              delete [] r_dcache_miss_buf; \
+                                          } while (0)
+# define CACHE_MISS_BUF_RESET(c)           
+# define CACHE_MISS_BUF_REQ_INIT(c,x)     do { \
+                                              for (uint32_t i=0; i<m_##c##cache_words;++i) \
+                                                  r_##c##cache_miss_val[x][i] = false; \
+                                          } while (0)
+# define CACHE_MISS_BUF_RSP_VAL(c,x,n)    r_##c##cache_miss_val[x][n]
+# define CACHE_MISS_BUF_RSP_ACK(c,x)      true
+# define CACHE_MISS_BUF_RSP_DATA(c,x,n)   r_##c##cache_miss_buf[x][n]
+# define CACHE_MISS_BUF_RSP_POP(c,x)         
+# define CACHE_MISS_BUF_RSP_PUSH(c,x,n,d) do { \
+                                              r_##c##cache_miss_val[x][n] = true; \
+                                              r_##c##cache_miss_buf[x][n] = d; \
+                                          } while (0)
+# define CACHE_MISS_BUF_RSP_PRINT(c)      do { \
+                                              for (uint32_t x=0; x<m_nb_##c##cache;++x) \
+                                                  for (uint32_t i=0; i<m_##c##cache_words;++i) \
+                                                      PRINTF("%d %x |",r_##c##cache_miss_val[x][i],r_##c##cache_miss_buf[x][i]); PRINTF("\n"); \
+                                          } while (0)
+#endif
+
+// =====[ MULTI_CACHE ]==============================
+
+#if (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+# define get_num_icache(     addr,num_cpu)   get_num_cache     (addr)          
+# define get_num_icache_only(addr,num_cpu)   get_num_cache_only(addr)          
+# define set_num_icache(     addr,num_cache) set_num_cache     (addr,num_cache)
+# define set_num_icache_only(addr,num_cache) set_num_cache_only(addr,num_cache)
+# define get_num_dcache(     addr)           get_num_cache     (addr)          
+# define get_num_dcache_only(addr)           get_num_cache_only(addr)          
+# define set_num_dcache(     addr,num_cache) set_num_cache     (addr,num_cache)
+# define set_num_dcache_only(addr,num_cache) set_num_cache_only(addr,num_cache)
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+# define get_num_icache(     addr,num_cpu)   num_cpu
+# define get_num_icache_only(addr,num_cpu)   num_cpu
+# define set_num_icache(     addr,num_cache) do  {} while (0)
+# define set_num_icache_only(addr,num_cache) addr
+# define get_num_dcache(     addr)           get_num_cache     (addr)          
+# define get_num_dcache_only(addr)           get_num_cache_only(addr)          
+# define set_num_dcache(     addr,num_cache) set_num_cache     (addr,num_cache)
+# define set_num_dcache_only(addr,num_cache) set_num_cache_only(addr,num_cache)
 #else
-# define CACHE_MISS_BUF_ALLOC           do { \
-                                        r_icache_miss_val = new bool  [m_icache_words]; \
-                                        r_icache_miss_buf = new data_t[m_icache_words]; \
-                                        r_dcache_miss_val = new bool  [m_dcache_words]; \
-                                        r_dcache_miss_buf = new data_t[m_dcache_words]; \
-                                        } while (0)
-# define CACHE_MISS_BUF_DEALLOC         do { \
-                                        delete [] r_icache_miss_val; \
-                                        delete [] r_icache_miss_buf; \
-                                        delete [] r_dcache_miss_val; \
-                                        delete [] r_dcache_miss_buf; \
-                                        } while (0)
-# define CACHE_MISS_BUF_RESET(c)
-# define CACHE_MISS_BUF_REQ_INIT(c)     do {for (uint32_t i=0; i<m_##c##cache_words;++i) r_##c##cache_miss_val[i] = false;} while (0)
-# define CACHE_MISS_BUF_RSP_VAL(c,n)    r_##c##cache_miss_val[n]
-# define CACHE_MISS_BUF_RSP_ACK(c)      true
-# define CACHE_MISS_BUF_RSP_DATA(c,n)   r_##c##cache_miss_buf[n]
-# define CACHE_MISS_BUF_RSP_POP(c)
-# define CACHE_MISS_BUF_RSP_PUSH(c,n,d) do {r_##c##cache_miss_val[n] = true; r_##c##cache_miss_buf[n] = d;} while (0)
-# define CACHE_MISS_BUF_RSP_PRINT(c)    do {for (uint32_t i=0; i<m_##c##cache_words;++i) PRINTF("%d %x |",r_##c##cache_miss_val[i],r_##c##cache_miss_buf[i]); PRINTF("\n");} while (0)
+#error "Invalid value to CC_XCACHE_WRAPPER_MULTI_CACHE"
 #endif
 
@@ -170,6 +248,7 @@
         const char *cleanup_fsm_state_str[] = {
             "CLEANUP_IDLE",
-            "CLEANUP_DCACHE",
-            "CLEANUP_ICACHE",
+            "CLEANUP_REQ",
+            "CLEANUP_RSP_DCACHE",
+            "CLEANUP_RSP_ICACHE",
         };
     }
@@ -189,4 +268,6 @@
             const soclib::common::IntTab &initiator_index_c,
             const soclib::common::IntTab &target_index,
+            size_t nb_cpu,
+            size_t nb_dcache,
             size_t icache_ways,
             size_t icache_sets,
@@ -210,51 +291,26 @@
             m_cacheability_table(mtp.getCacheabilityTable<vci_addr_t>()),
             m_segment(mtc.getSegment(target_index)),
-            m_iss(this->name(), proc_id),
             m_srcid_rw(mtp.indexForId(initiator_index_rw)),
             m_srcid_c(mtc.indexForId(initiator_index_c)),
 
+            m_nb_cpu(nb_cpu),
+#if   (CC_XCACHE_WRAPPER_MULTI_CACHE==1)
+            m_nb_icache(nb_dcache),
+#elif (CC_XCACHE_WRAPPER_MULTI_CACHE==2)
+            m_nb_icache(m_nb_cpu),
+#endif
+            m_nb_dcache(nb_dcache),
+            m_nb_cache((m_nb_dcache>m_nb_icache)?m_nb_dcache:m_nb_icache),
             m_dcache_ways(dcache_ways),
             m_dcache_words(dcache_words),
-            m_dcache_words_shift(uint32_log2(dcache_words)+2),
+            m_dcache_words_shift(uint32_log2(dcache_words)+uint32_log2(sizeof(data_t))),
             m_dcache_yzmask((~0)<<m_dcache_words_shift),
             m_icache_ways(icache_ways),
             m_icache_words(icache_words),
-            m_icache_words_shift(uint32_log2(icache_words)+2),
+            m_icache_words_shift(uint32_log2(icache_words)+uint32_log2(sizeof(data_t))),
             m_icache_yzmask((~0)<<m_icache_words_shift),
             m_cache_words((dcache_words)?dcache_words:icache_words),
 
-            r_dcache_fsm("r_dcache_fsm"),
-            r_dcache_fsm_save("r_dcache_fsm_save"),
-            r_dcache_addr_save("r_dcache_addr_save"),
-            r_dcache_wdata_save("r_dcache_wdata_save"),
-            r_dcache_rdata_save("r_dcache_rdata_save"),
-            r_dcache_type_save("r_dcache_type_save"),
-            r_dcache_be_save("r_dcache_be_save"),
-            r_dcache_cached_save("r_dcache_cached_save"),
-            r_dcache_cleanup_req("r_dcache_cleanup_req"),
-            r_dcache_cleanup_line("r_dcache_cleanup_line"),
-            r_dcache_miss_req("r_dcache_miss_req"),
-            r_dcache_miss_way("r_dcache_miss_way"),
-            r_dcache_miss_set("r_dcache_miss_set"),
-            r_dcache_unc_req("r_dcache_unc_req"),
-            r_dcache_sc_req("r_dcache_sc_req"),
-            r_dcache_inval_rsp("r_dcache_inval_rsp"),
-            r_dcache_update_addr("r_dcache_update_addr"),
-            r_dcache_ll_data("r_dcache_ll_data"),
-            r_dcache_ll_addr("r_dcache_ll_addr"),
-            r_dcache_ll_valid("r_dcache_ll_valid"),
-            r_dcache_previous_unc("r_dcache_previous_unc"),
-
-            r_icache_fsm("r_icache_fsm"),
-            r_icache_fsm_save("r_icache_fsm_save"),
-            r_icache_addr_save("r_icache_addr_save"),
-            r_icache_miss_req("r_icache_miss_req"),
-            r_icache_miss_way("r_icache_miss_way"),
-            r_icache_miss_set("r_icache_miss_set"),
-            r_icache_unc_req("r_icache_unc_req"),
-            r_icache_cleanup_req("r_icache_cleanup_req"),
-            r_icache_cleanup_line("r_icache_cleanup_line"),
-            r_icache_inval_rsp("r_icache_inval_rsp"),
-            r_icache_update_addr("r_icache_update_addr"),
+            r_cpu_prior("r_cpu_prior"),
 
             r_vci_cmd_fsm("r_vci_cmd_fsm"),
@@ -263,12 +319,10 @@
             r_vci_cmd_cpt("r_vci_cmd_cpt"),
             r_vci_cmd_dcache_prior("r_vci_cmd_dcache_prior"),
+            r_vci_cmd_num_cache("r_vci_cmd_num_cache"),
 
             r_vci_rsp_fsm("r_vci_rsp_fsm"),
-            r_vci_rsp_ins_error("r_vci_rsp_ins_error"),
-            r_vci_rsp_data_error("r_vci_rsp_data_error"),
             r_vci_rsp_cpt("r_vci_rsp_cpt"),
-            r_vci_rsp_ack("r_vci_rsp_ack"),
-
-            r_icache_buf_unc_valid("r_icache_buf_unc_valid"),
+          //s_vci_rsp_ack("s_vci_rsp_ack"),
+            r_vci_rsp_num_cache("r_vci_rsp_num_cache"),
 
 #if CC_XCACHE_WRAPPER_CC_UPDATE_MULTI_CYCLE
@@ -277,5 +331,6 @@
 
             r_vci_tgt_fsm("r_vci_tgt_fsm"),
-            r_tgt_addr("r_tgt_addr"),
+            r_tgt_iaddr("r_tgt_iaddr"),
+            r_tgt_daddr("r_tgt_daddr"),
             r_tgt_word("r_tgt_word"),
             r_tgt_update("r_tgt_update"),
@@ -286,26 +341,236 @@
             r_tgt_trdid("r_tgt_trdid"),
          // r_tgt_plen("r_tgt_plen"),
-            r_tgt_icache_req("r_tgt_icache_req"),
-            r_tgt_dcache_req("r_tgt_dcache_req"),
-            r_tgt_icache_rsp("r_tgt_icache_rsp"),
-            r_tgt_dcache_rsp("r_tgt_dcache_rsp"),
+            r_tgt_num_cache("r_tgt_num_cache"),
 
             r_cleanup_fsm("r_cleanup_fsm"),
-
-            r_wbuf("r_wbuf", wbuf_nwords, wbuf_nlines, wbuf_timeout, dcache_words),
-            r_icache("icache", icache_ways, icache_sets, icache_words),
-            r_dcache("dcache", dcache_ways, dcache_sets, dcache_words)
+            r_cleanup_num_cache("r_cleanup_num_cache"),
+            r_cleanup_icache("r_cleanup_icache"),
+
+            m_num_cache_LSB(uint32_log2(icache_words) + uint32_log2(sizeof(data_t))),
+            m_num_cache_MSB(uint32_log2(nb_dcache) + m_num_cache_LSB)
             {
                 // Size of word is 32 bits
-                ASSERT( (icache_words*vci_param::B) < (1<<vci_param::K),
-                        "I need more PLEN bits");
-
-                ASSERT( (vci_param::T > 2) and ((1<<(vci_param::T-1)) >= wbuf_nlines),
-                        "I need more TRDID bits");
-
+                ASSERT((icache_words*vci_param::B) < (1<<vci_param::K),
+                       "Need more PLEN bits.");
+
+                ASSERT((vci_param::T > 2) and ((1<<(vci_param::T-1)) >= (wbuf_nlines/m_nb_dcache)),
+                       "Need more TRDID bits.");
+
+                ASSERT(uint32_log2(nb_dcache) <= (1<<vci_param::P),
+                       "Need more PKTID bits.");
+                
+                ASSERT(IS_POW_OF_2(m_nb_dcache),
+                       "nb_dcache must be a power of 2.");
+
+                ASSERT(IS_POW_OF_2(m_nb_cpu) and (m_nb_cpu <= m_nb_dcache) and (m_nb_cpu > 0),
+                       "nb cpu must be a multiple of nb cache.");
+
+                ASSERT(IS_POW_OF_2(m_icache_ways) and (m_nb_icache <= m_icache_ways),
+                       "nb icache ways must be a multiple of nb cache.");
+
+                ASSERT(IS_POW_OF_2(m_dcache_ways) and (m_nb_dcache <= m_dcache_ways),
+                       "nb dcache ways must be a multiple of nb cache.");
+
+                ASSERT(icache_words == dcache_words,
+                       "icache_words must be equal at dcache_words.");
+
+                ASSERT(IS_POW_OF_2(wbuf_nlines) and (m_nb_dcache <= wbuf_nlines),
+                       "wbuf_nlines must be a multiple of nb cache.");
+
+                // FIXME : s'adapter à la taille des requêtes XTN_READ/XTN_WRITE
+                ASSERT((m_nb_dcache == 1) or (dcache_words >= 16),
+                       "When multi cache is activated, need 4 bits (16 word) to the cache set .");
+
+                p_irq = new sc_in<bool> * [m_nb_cpu];
+                for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                    p_irq [num_cpu] = new sc_in<bool> [iss_t::n_irq];
+
+                m_iss = new iss_t * [m_nb_cpu];
+                for (uint32_t num_cpu=0; num_cpu<m_nb_cpu; ++num_cpu)
+                {
+                    std::ostringstream iss_name("");
+                    iss_name << this->name() << "_" << num_cpu;
+
+                    m_iss[num_cpu] = new iss_t (iss_name.str().c_str(), proc_id+num_cpu);
+                }
+                
                 CACHE_MISS_BUF_ALLOC;
 
-                r_tgt_buf = new data_t[m_cache_words];
-                r_tgt_be  = new be_t  [m_cache_words];
+                r_icache_lock          = new sc_signal<uint32_t>[m_nb_icache];
+                r_dcache_lock          = new sc_signal<uint32_t>[m_nb_dcache];
+                r_dcache_sync          = new sc_signal<bool>    [m_nb_dcache];
+
+                r_icache_fsm           = new sc_signal<int>     [m_nb_icache];
+                r_icache_fsm_save      = new sc_signal<int>     [m_nb_icache];
+                r_icache_addr_save     = new sc_signal<addr_40> [m_nb_icache];
+                r_icache_miss_req      = new sc_signal<bool>    [m_nb_icache];
+                r_icache_miss_way      = new sc_signal<size_t>  [m_nb_icache];
+                r_icache_miss_set      = new sc_signal<size_t>  [m_nb_icache];
+                r_icache_unc_req       = new sc_signal<bool>    [m_nb_icache];
+                r_icache_cleanup_req   = new sc_signal<bool>    [m_nb_icache];
+                r_icache_cleanup_line  = new sc_signal<addr_40> [m_nb_icache];
+                r_icache_inval_rsp     = new sc_signal<bool>    [m_nb_icache];
+                r_icache_update_addr   = new sc_signal<size_t>  [m_nb_icache];
+                r_icache_buf_unc_valid = new sc_signal<bool>    [m_nb_icache];
+
+                r_dcache_fsm           = new sc_signal<int>     [m_nb_dcache];
+                r_dcache_fsm_save      = new sc_signal<int>     [m_nb_dcache];
+                r_dcache_addr_save     = new sc_signal<addr_40> [m_nb_dcache];
+                r_dcache_wdata_save    = new sc_signal<data_t>  [m_nb_dcache];
+                r_dcache_rdata_save    = new sc_signal<data_t>  [m_nb_dcache];
+                r_dcache_type_save     = new sc_signal<int>     [m_nb_dcache];
+                r_dcache_be_save       = new sc_signal<be_t>    [m_nb_dcache];
+                r_dcache_cached_save   = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_cleanup_req   = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_cleanup_line  = new sc_signal<addr_40> [m_nb_dcache];
+                r_dcache_miss_req      = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_miss_way      = new sc_signal<size_t>  [m_nb_dcache];
+                r_dcache_miss_set      = new sc_signal<size_t>  [m_nb_dcache];
+                r_dcache_unc_req       = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_sc_req        = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_inval_rsp     = new sc_signal<bool>    [m_nb_dcache];
+                r_dcache_update_addr   = new sc_signal<size_t>  [m_nb_dcache];
+                r_dcache_previous_unc  = new sc_signal<bool>    [m_nb_dcache];
+
+                r_dcache_num_cpu_save  = new sc_signal<uint32_t>   [m_nb_dcache];
+                r_dcache_ll_data       = new sc_signal<data_64>  * [m_nb_dcache];
+                r_dcache_ll_addr       = new sc_signal<addr_40>  * [m_nb_dcache];
+                r_dcache_ll_valid      = new sc_signal<bool>     * [m_nb_dcache];
+                for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                {
+                    r_dcache_ll_data    [num_cache] = new sc_signal<data_64>  [m_nb_cpu];
+                    r_dcache_ll_addr    [num_cache] = new sc_signal<addr_40>  [m_nb_cpu];
+                    r_dcache_ll_valid   [num_cache] = new sc_signal<bool>     [m_nb_cpu];
+                }
+
+                r_tgt_icache_req       = new sc_signal<bool>    [m_nb_icache];
+                r_tgt_icache_rsp       = new sc_signal<bool>    [m_nb_icache];
+                r_tgt_dcache_req       = new sc_signal<bool>    [m_nb_dcache];
+                r_tgt_dcache_rsp       = new sc_signal<bool>    [m_nb_dcache];
+
+                r_tgt_buf              = new data_t             [m_cache_words];
+                r_tgt_be               = new be_t               [m_cache_words];
+
+                r_vci_rsp_ins_error    = new sc_signal<bool>    [m_nb_icache];
+                r_vci_rsp_data_error   = new sc_signal<bool>    [m_nb_dcache];
+
+                ireq                   = new typename iss_t::InstructionRequest  [m_nb_icache];
+                irsp                   = new typename iss_t::InstructionResponse [m_nb_icache];
+                ireq_cached            = new bool                                [m_nb_icache];
+                ireq_num_cpu           = new uint32_t                            [m_nb_dcache];
+
+                dreq                   = new typename iss_t::DataRequest         [m_nb_dcache];
+                drsp                   = new typename iss_t::DataResponse        [m_nb_dcache];
+                dreq_cached            = new bool                                [m_nb_dcache];
+                dreq_num_cpu           = new uint32_t                            [m_nb_dcache];
+
+                m_cpt_icache_access = new uint32_t [m_nb_icache];
+                m_cpt_dcache_access = new uint32_t [m_nb_dcache];
+
+               
+                m_cpt_fsm_dcache  = new uint32_t * [m_nb_dcache];
+                m_cpt_fsm_icache  = new uint32_t * [m_nb_icache];
+                for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                    m_cpt_fsm_dcache[num_cache]  = new uint32_t [soclib::common::size(dcache_fsm_state_str )];
+                for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                    m_cpt_fsm_icache[num_cache]  = new uint32_t [soclib::common::size(icache_fsm_state_str )];
+                m_cpt_fsm_cmd     = new uint32_t [soclib::common::size(cmd_fsm_state_str    )];
+                m_cpt_fsm_rsp     = new uint32_t [soclib::common::size(rsp_fsm_state_str    )];
+                m_cpt_fsm_tgt     = new uint32_t [soclib::common::size(tgt_fsm_state_str    )];
+                m_cpt_fsm_cleanup = new uint32_t [soclib::common::size(cleanup_fsm_state_str)];
+
+                m_cpt_frz_cycles  = new uint32_t [m_nb_cpu];
+                // r_icache_fsm("r_icache_fsm"),
+                // r_icache_fsm_save("r_icache_fsm_save"),
+                // r_icache_addr_save("r_icache_addr_save"),
+                // r_icache_miss_req("r_icache_miss_req"),
+                // r_icache_miss_way("r_icache_miss_way"),
+                // r_icache_miss_set("r_icache_miss_set"),
+                // r_icache_unc_req("r_icache_unc_req"),
+                // r_icache_cleanup_req("r_icache_cleanup_req"),
+                // r_icache_cleanup_line("r_icache_cleanup_line"),
+                // r_icache_inval_rsp("r_icache_inval_rsp"),
+                // r_icache_update_addr("r_icache_update_addr"),
+                // r_icache_buf_unc_valid("r_icache_buf_unc_valid"),
+
+                // r_dcache_fsm("r_dcache_fsm"),
+                // r_dcache_fsm_save("r_dcache_fsm_save"),
+                // r_dcache_addr_save("r_dcache_addr_save"),
+                // r_dcache_wdata_save("r_dcache_wdata_save"),
+                // r_dcache_rdata_save("r_dcache_rdata_save"),
+                // r_dcache_type_save("r_dcache_type_save"),
+                // r_dcache_be_save("r_dcache_be_save"),
+                // r_dcache_cached_save("r_dcache_cached_save"),
+                // r_dcache_cleanup_req("r_dcache_cleanup_req"),
+                // r_dcache_cleanup_line("r_dcache_cleanup_line"),
+                // r_dcache_miss_req("r_dcache_miss_req"),
+                // r_dcache_miss_way("r_dcache_miss_way"),
+                // r_dcache_miss_set("r_dcache_miss_set"),
+                // r_dcache_unc_req("r_dcache_unc_req"),
+                // r_dcache_sc_req("r_dcache_sc_req"),
+                // r_dcache_inval_rsp("r_dcache_inval_rsp"),
+                // r_dcache_update_addr("r_dcache_update_addr"),
+                // r_dcache_ll_data("r_dcache_ll_data"),
+                // r_dcache_ll_addr("r_dcache_ll_addr"),
+                // r_dcache_ll_valid("r_dcache_ll_valid"),
+                // r_dcache_previous_unc("r_dcache_previous_unc"),
+
+                // r_tgt_icache_req("r_tgt_icache_req"),
+                // r_tgt_icache_rsp("r_tgt_icache_rsp"),
+
+                // r_tgt_dcache_req("r_tgt_dcache_req"),
+                // r_tgt_dcache_rsp("r_tgt_dcache_rsp"),
+
+                // r_vci_rsp_ins_error("r_vci_rsp_ins_error"),
+                // r_vci_rsp_data_error("r_vci_rsp_data_error"),
+
+                size_t _icache_ways  = icache_ways /m_nb_icache;
+                size_t _icache_sets  = icache_sets ;
+                size_t _dcache_ways  = dcache_ways /m_nb_dcache;
+                size_t _dcache_sets  = dcache_sets ;
+                size_t _icache_words = icache_words;
+                size_t _dcache_words = dcache_words;
+
+                size_t _wbuf_nwords  = wbuf_nwords ;
+                size_t _wbuf_nlines  = wbuf_nlines /m_nb_dcache;
+                size_t _wbuf_timeout = wbuf_timeout;
+
+
+                std::cout << "<VciCcXCacheWrapperV4> Parameters :" << std::endl;
+                std::cout << "  * nb_cpu             : " << nb_cpu << std::endl;
+                std::cout << "  * nb_cache           : " << m_nb_icache << " icache(s), " << m_nb_dcache << " dcache(s)" << std::endl;
+                std::cout << "  * icache (total)     : " <<  icache_ways << " way(s), " <<  icache_sets << " set(s), " <<  icache_words << " word(s)" << std::endl;
+                std::cout << "  * icache (per cache) : " << _icache_ways << " way(s), " << _icache_sets << " set(s), " << _icache_words << " word(s)" << std::endl;
+                std::cout << "  * dcache (total)     : " <<  dcache_ways << " way(s), " <<  dcache_sets << " set(s), " <<  dcache_words << " word(s)" << std::endl;
+                std::cout << "  * dcache (per cache) : " << _dcache_ways << " way(s), " << _dcache_sets << " set(s), " << _dcache_words << " word(s)" << std::endl;
+                std::cout << "  * wbuf   (total)     : " <<  wbuf_nlines << " line(s), " <<  wbuf_nwords << " word(s), timeout : " <<  wbuf_timeout << std::endl;
+                std::cout << "  * wbuf   (per cache) : " << _wbuf_nlines << " line(s), " << _wbuf_nwords << " word(s), timeout : " << _wbuf_timeout << std::endl;
+
+                r_icache = new GenericCache<vci_addr_t>  * [m_nb_icache];
+                r_dcache = new GenericCache<vci_addr_t>  * [m_nb_dcache];
+                r_wbuf   = new MultiWriteBuffer<addr_40> * [m_nb_dcache];
+
+               for (uint32_t num_cache=0; num_cache<m_nb_icache; ++num_cache)
+                {
+                    r_icache [num_cache] = new GenericCache<vci_addr_t>  ("icache", _icache_ways, _icache_sets, _icache_words);
+                }
+               for (uint32_t num_cache=0; num_cache<m_nb_dcache; ++num_cache)
+                {
+                    r_dcache [num_cache] = new GenericCache<vci_addr_t>  ("dcache", _dcache_ways, _dcache_sets, _dcache_words);
+                    r_wbuf   [num_cache] = new MultiWriteBuffer<addr_40> ("r_wbuf", _wbuf_nwords, _wbuf_nlines, _wbuf_timeout, _dcache_words);
+                }
+
+                m_num_cache_LSB_mask = 0;
+                for (uint32_t i=0; i<m_num_cache_LSB; ++i)
+                {
+                    m_num_cache_LSB_mask <<= 1;
+                    m_num_cache_LSB_mask  |= 1;
+                }
+                m_num_cache_mask = 0;
+                for (uint32_t i=0; i<(m_num_cache_MSB-m_num_cache_LSB); ++i)
+                {
+                    m_num_cache_mask <<= 1;
+                    m_num_cache_mask  |= 1;
+                }
 
                 SC_METHOD(transition);
@@ -316,5 +581,4 @@
                 dont_initialize();
                 sensitive << p_clk.neg();
-
 
                 typename iss_t::CacheInfo cache_info;
